#pragma once on
/*
	AEObj_pd.h
	 Bob Boylan 1996
	
	Revision History
	MacHack 1996	initial creation
*/
#include "BaseTypes.h"
#include "PropertyValue_pd.h"
#include "Clone_ut.h"
#include "AETE_da.h"
#include "ObjectSpec_da.h"

#include <UAppleEventsMgr.h>
#include <vector.h>
#include <stack.h>

class ProgressProc_hi;



class AEObj_pd
{
public:
	// ctor
		AEObj_pd();
		AEObj_pd( AEObj_pd * inParent, DescType inKind, Int_32 inIndex );
		AEObj_pd( AEObj_pd * inChild );
	// dtor
		virtual	~AEObj_pd();
	
	//	Update - will grab the latest data from the object
		virtual	
		void	Update( ProgressProc_hi &inProgressProc, Int_32 inMaxSubModels );
	
	// getters
		virtual
		Clone_ut<PropertyValue_pd>	GetPropertyValue( Prop_da &inProp );

		virtual
		string						GetName();

		virtual
		string						GetFullName();

		virtual
		string						GetKindName();

		virtual
		DescType					GetKindID();

		virtual
		Int_32						GetPosition();
	
		virtual
		Int_32			GetSubModelCount( DescType inModelKind );
		
		virtual
		string		GetObjAddr();
		
		
		virtual
		void *		GetAppAddr();
		
		virtual
		OSType		GetAppAddrType();
		
		virtual
		Int_32		GetSizeofAppAddr();
	
		virtual
		Clone_ut< AETE_da >	GetAETE();


	// Walking the hierarchy
		virtual
		Clone_ut< AEObj_pd >	GetParent();
		virtual
		Clone_ut< AEObj_pd >	GetSibling( Int_32 inPositionDelta );

	// questions?
		virtual
		Boolean		IsValidAETE();

protected:

	// getting doer function
		virtual
		string		GetObjAddrR( vector<ObjectSpec_da>::iterator &ioIter );

	// Updaters
		virtual
		void		UpdatePropertyValues(  ProgressProc_hi &inProgressProc , DescType inPropertyID = typeNull);
		virtual
		void		UpdateSubModelList(  ProgressProc_hi &inProgressProc, Int_32 inMaxSubModels  );

	// setter of object spec	
		virtual
		void		PushObjSpec( ObjectSpec_da &inObjSpec );

	// data
		vector <ObjectSpec_da> 				_ObjectSpec;
		Clone_ut< AETE_da >					_AETE;
	
		OSType								_AppSignature;

private:

	// timeout when waiting for ae reply
		static Int_32	_TimeoutinTicks;

};
