#pragma once on
/*
	AppAEObj_pd.h
	 Bob Boylan 1996

	Revision History
	MacHack 1996		initial creation
*/
#include "BaseTypes.h"
#include "AEObj_pd.h"
#include "Clone_ut.h"

#include <vector.h>




class AppAEObj_pd : public AEObj_pd
{
public:
	// ctor
				AppAEObj_pd( AEObj_pd * inParent, DescType inKind, Int_32 inIndex );
				AppAEObj_pd( AEObj_pd * inChild );
	// dtor
		virtual	~AppAEObj_pd();
	
	//	Update - will grab the latest data from the App
		virtual	
		void	Update( ProgressProc_hi &inProgressProc, Int_32 inMaxSubModels );
	
	// getters	
		virtual
		string			GetKindName() { return string("Application") ; }
	
		virtual
		Clone_ut< AEObj_pd >	GetParent();

		virtual
		string			GetName();

	// questions
		virtual
		Boolean		IsScriptable();

		virtual
		Boolean		IsValidAETE();

	
protected:
	
	// access to finder data
		virtual
		PropertyValue_pd	GetProcessPropertyValue( DescType inKind );

		virtual
		void *		GetFinderAppAddr();
		virtual
		OSType		GetFinderAppAddrType();
		virtual
		Int_32		GetSizeofFinderAppAddr();
	
	// finder data		
		OSType		_FinderAppAddr;
		OSType		_FinderAppAddrType;
		Int_32		_SizeofFinderAppAddr;
	
	// class data
		Boolean		_HaveAppAddr;	
	
private:

};
