/*
	FinderFinderAppAEObj_pd.h
	 Bob Boylan 1996

	Revision History
	MacHack 1996		initial creation
*/
#include "debug.h"
#include "FinderAppAEObj_pd.h"
#include "PropertyValue_pd.h"
#include "ComputerAETE_da.h"
#include "Helpers_ut.h"
#include "FinderAETE_da.h"
#include "AEBuild.h"

#include <string.h>
#include <sstream>



//	-----------------------------------------------------------------
//	ctor
//
FinderAppAEObj_pd::FinderAppAEObj_pd( AEObj_pd * inParent, DescType inKind, Int_32 inIndex )
	: AppAEObj_pd( inParent, inKind, inIndex )
{

}
//	-----------------------------------------------------------------
//	dtor
//
FinderAppAEObj_pd::~FinderAppAEObj_pd()
{}
//	-----------------------------------------------------------------
//	Update
//
void
FinderAppAEObj_pd::Update( ProgressProc_hi &inProgressProc, Int_32 inMaxSubModels )
{
	// make sure the application address is proper
	if( _HaveAppAddr == false )
	{
		_AppSignature = 'MACS';
		IsValidAETE();
		_HaveAppAddr = true;
	}
	

	if( _HaveAppAddr == true )
	{
		AEObj_pd::Update( inProgressProc, inMaxSubModels );
	}
}
	

//	-----------------------------------------------------------------
//	IsScriptable ... of course
//
Boolean
FinderAppAEObj_pd::IsScriptable()
{
	return true;
}




//	-----------------------------------------------------------------
//	GetName
//
string
FinderAppAEObj_pd::GetName()
{
string	theRetVal = string("Finder");
	return theRetVal;
}
//	-----------------------------------------------------------------
//	IsValidAETE
//
Boolean
FinderAppAEObj_pd::IsValidAETE()
{
	if( (_AETE.Isnil() == true) && (_HaveAppAddr == false) )
	{
		AETE_da *theAETE = new FinderAETE_da( this );
		Clone_ut< AETE_da >	theClonedAETE( theAETE );
		_AETE = theClonedAETE;
	}
	return !(_AETE.Isnil());

}
